C LAST UPDATE: 
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C**************************
C**     LDM_DFSET_PK     **
C**************************
C
C
      SUBROUTINE LDM_DFSET_PK (IPACK, PAR, DF_PAR, IS_PAR, CH_PAR,
     +                        DF_IS_PAR, ND_PAR, DF_ND_PAR,
     +                        IERR, ERRSTR, MAXPK)
C
      INCLUDE 'implicit_none.finc'
C
C Purpose: Set default values for a pack based real parameter 
C
C ***** 'LDM' SERVICE ROUTINE ONLY *****
C
C Author:  John W. Campbell, June 1993
C
C Arguments:
C
      INTEGER IPACK
      INTEGER MAXPK
      REAL PAR(MAXPK)
      REAL DF_PAR
      INTEGER IS_PAR(MAXPK)
      INTEGER CH_PAR(MAXPK)
      INTEGER DF_IS_PAR
      INTEGER ND_PAR(MAXPK)
      INTEGER DF_ND_PAR
      INTEGER IERR
      CHARACTER*(*) ERRSTR

C  IPACK     (R)   Pack number, 0=all packs
C  PAR       (W)   Array containing parameter values to be set
C  DF_PAR    (R)   Default value for the parameter
C  IS_PAR    (W)   Array containing IS flags to be set
C  CH_PAR    (W)   Array containing CH flags to be set
C  DF_IS_PAR (R)   Default value for the IS flags
C  ND_PAR    (W)   Array containing ND flags to be set
C  DF_ND_PAR (R)   Default value for the ND flags
C  IERR      (W)   Error flag = 0 OK
C                             =-1 Invalid pack specification
C  ERRSTR    (W)   Error string
C  MAXPK     (R)   Packs array dimension
C
C====== GLOBALS:
C
      INCLUDE 'ldm_data.finc'
C
C====== LOCALS:
C
      INTEGER I
C
C-------------------------------------------------------------------------------
C
      CALL LDM_CHK_SPK (IPACK, IERR, ERRSTR)
      IF (IERR.NE.0) RETURN
      IF (IPACK.EQ.0) THEN
         DO 100 I = 1, MAXPK
            PAR(I) = DF_PAR
            IS_PAR(I) = DF_IS_PAR
            CH_PAR(I) = CH_MASK
            ND_PAR(I) = DF_ND_PAR
100      CONTINUE
      ELSE        
         PAR(IPACK) = DF_PAR
         IS_PAR(IPACK) = DF_IS_PAR
         CH_PAR(IPACK) = CH_MASK
         ND_PAR(IPACK) = DF_ND_PAR
      END IF
      RETURN
      END
