C LAST UPDATE: 
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C****************************
C**     LDM_GET_NSYM       **
C****************************
C
CD-Routine: Get Number of Symmetry Operators - LDM_GET_NSYM
C This routine returns the number of symmetry operators or 0 if no symmetry
C has been defined. This provides the simplest way of determining whether
C the symmetry has been defined.         
CD-end
CD-Fortran:
      SUBROUTINE LDM_GET_NSYM (NSYMM, IFLAG)
CD-end
      INCLUDE 'implicit_none.finc'
C
C Purpose: See if symmetry data was defined
C
C Author:  John W. Campbell, July 1993
C
C Arguments:
C
      INTEGER NSYMM
      INTEGER IFLAG

CD-Parameters:
C  NSYMM    i (W)   Total number of symmetry operators (0 if symmetry not
C                   defined)
C  IFLAG    i (W)   Flag = -1 undefined value
C                        =  0 default value
C                        =  1 value set explicitly
C                        =  2 value set globally
CD-end
C
C====== GLOBALS:
C
      INCLUDE 'ldm_data.finc'
      EXTERNAL LDM_BDAT
C
C====== LOCALS:
C

C
C-------------------------------------------------------------------------------
C
      NSYMM = NSYM
      IFLAG = IS_SYMM
      RETURN
      END
