C LAST UPDATE: 
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C**************************
C**     LDM_GET_SYST     **
C**************************
C
C
CD-Doc:
C SYSTem           SUBROUTINE LDM_GET_SYST (VALSTR, IVAL, IFLAG)
CD-end
      SUBROUTINE LDM_GET_SYST (VALSTR, IVAL, IFLAG)
C
      INCLUDE 'implicit_none.finc'
C
C Purpose: Get value of string/code parameter SYSTEM
C
C Author:  John W. Campbell, June 1993
C
C Arguments:
C
      CHARACTER*(*) VALSTR
      INTEGER IVAL
      INTEGER IFLAG

C  VALSTR    (W)   Value for the parameter as a string (12 chars)
C                        Triclinic
C                        Monoclinic
C                        Orthorhombic
C                        Tetragonal
C                        Hexagonal
C                        Rhombohedral
C                        Cubic
C  IVAL      (W)   Crystal system no. 1-7 1=Triclinic...7=Cubic
C  IFLAG     (W)   Flag = -1 undefined value
C                       =  0 default value
C                       =  1 value set explicitly
C                       =  2 value set globally
C
C====== GLOBALS:
C
      INCLUDE 'ldm_data.finc'
      EXTERNAL LDM_BDAT
C
C====== LOCALS:
C
      CHARACTER*(12) STR(7)

      DATA STR/'Triclinic',
     +         'Monoclinic',
     +         'Orthorhombic',
     +         'Tetragonal',
     +         'Hexagonal',
     +         'Rhombohedral',
     +         'Cubic'/
C
C-------------------------------------------------------------------------------
C
      IVAL = SYST
      VALSTR = STR(IVAL)
      IFLAG = IS_SYST
      RETURN
      END
