C LAST UPDATE: 
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C****************************
C**     LDM_SET_FBOX       **
C****************************
C
C
CD-Doc:
C FIDBox           SUBROUTINE LDM_SET_FBOX (VALUE, IERR, ERRSTR)
CD-end
      SUBROUTINE LDM_SET_FBOX (VALUE, IERR, ERRSTR)
C
      INCLUDE 'implicit_none.finc'
C
C Purpose: Set value of real parameter FIDBOX
C
C Author:  John W. Campbell, June 1993
C
C Arguments:
C
      REAL VALUE
      INTEGER IERR
      CHARACTER*(*) ERRSTR

C  VALUE     (R)   Box size for fids search (mm) >= 0.0
C  IERR      (W)   Error flag =0 OK
C                             =2 Value must be >=0.0
C  ERRSTR    (W)   Error description string if error found
C
C====== GLOBALS:
C
      INCLUDE 'ldm_data.finc'
      EXTERNAL LDM_BDAT
C
C====== LOCALS:
C

C
C-------------------------------------------------------------------------------
C
      CALL LDM_ERR_R (VALUE, 2, 0.0, 0.0, 1, IERR, ERRSTR)
      IF (IERR.NE.0) RETURN
      FBOX = VALUE
      IS_FBOX = 1
      CH_FBOX = CH_MASK
      ND_FBOX = -1000
      RETURN
      END
