C LAST UPDATE: 
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C****************************
C**     LDM_SET_IMTYP      **
C****************************
C
C
CD-Doc:
C IMAGE_Type       SUBROUTINE LDM_SET_IMTYP (VALSTR, IVAL, IERR, ERRSTR)
CD-end
      SUBROUTINE LDM_SET_IMTYP (VALSTR, IVAL, IERR, ERRSTR)
C
      INCLUDE 'implicit_none.finc'
C
C Purpose: Set value of code/integer parameter IMAGE_TYPE
C
C Author:  John W. Campbell, June 1993
C
C Arguments:
C
      CHARACTER*(*) VALSTR
      INTEGER IVAL
      INTEGER IERR
      CHARACTER*(*) ERRSTR

C  VALSTR    (R)   Code to be checked and decoded; if blank use IVAL instead
C                  full code checked must be 'film', 'ip', 'smv',
C                  'marccd', 'tiff', or 'marpck'
C  IVAL      (R)   Value for the parameter (used if VALSTR = ' ')
C                  allowed values are:
C                  1=film, 2=ip, 3=smv, 4=marccd, 5=tiff, 6=marpck
C  IERR      (W)   Error flag =0 OK
C                             =1 Invalid code or syntax error in string
C                             =3 Value must be >0
C                             =4 Value out of range (other)
C  ERRSTR    (W)   Error description string if error found
C
C====== GLOBALS:
C
      INCLUDE 'ldm_data.finc'
      EXTERNAL LDM_BDAT
C
C====== LOCALS:
C
      INTEGER I
      INTEGER IT
      CHARACTER*6 TYPE(7)
      CHARACTER*6 CODE

C     INTEGER I              !Loop variable
C     INTEGER IT             !Type code
C     CHARACTER*6 TYPE(7)    !Valid image type strings
C     CHARACTER*6 CODE       !Code for matching (upper case

      DATA TYPE /'FILM','IP','SMV','MARCCD','TIFF','MARPCK','ADSC'/
C
C-------------------------------------------------------------------------------
C
      IERR = 0
      ERRSTR = ' '
      IF (VALSTR.NE.' ') THEN
         CODE = VALSTR
         CALL CCPUPC(CODE)
         DO 100 I = 1,7
            IT = I
            IF (CODE.EQ.TYPE(I)) GO TO 120
100      CONTINUE
         IERR = 1
         ERRSTR = 
     +   'Invalid code - use film, ip, smv, marccd, tiff, or marpck'
         RETURN
120      IMTYP = IT
C SMV AND ADSC ARE THE SAME FORMAT
         IF (IMTYP.EQ.7) IMTYP=3
      ELSE
         CALL LDM_ERR_I (IVAL, 1, 6, IERR, ERRSTR)
         IF (IERR.NE.0) RETURN
         IMTYP = IVAL
      END IF
      IS_IMTYP = 1
      CH_IMTYP = CH_MASK
      RETURN
      END
