C LAST UPDATE: 
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C*****************************
C**     LDM_SET_NPLAT       **
C*****************************
C
C
CD-Doc:
C NPLAtes          SUBROUTINE LDM_SET_NPLAT (IVAL, IERR, ERRSTR)
CD-end
      SUBROUTINE LDM_SET_NPLAT (IVAL, IERR, ERRSTR)
C
      INCLUDE 'implicit_none.finc'
C
C Purpose: Set value of integer parameter NPLATES
C
C Author:  John W. Campbell, June 1993
C
C Arguments:
C
      INTEGER IVAL
      INTEGER IERR
      CHARACTER*(*) ERRSTR

C  IVAL      (R)   Number of plates in a pack (> 0 )
C                  up to LDM max. allowed value.
C  IERR      (W)   Error flag =0 OK
C                             =3 Value must be >0
C                             =4 Value out of range (other)
C  ERRSTR    (W)   Error description string if error found
C
C====== GLOBALS:
C
      INCLUDE 'ldm_data.finc'
      EXTERNAL LDM_BDAT
C
C====== LOCALS:
C

C
C-------------------------------------------------------------------------------
C
      CALL LDM_ERR_I (IVAL, 1, LDM_MAXPL, IERR, ERRSTR)
      IF (IERR.NE.0) RETURN
      NPLAT = IVAL
      IS_NPLAT = 1
      CH_NPLAT = CH_MASK
      RETURN
      END
