C LAST UPDATE: 
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C****************************
C**     LDM_SET_NYRAS      **
C****************************
C
C
CD-Doc:
C NYRAst           SUBROUTINE LDM_SET_NYRAS (IVAL, IERR, ERRSTR)
CD-end
      SUBROUTINE LDM_SET_NYRAS (IVAL, IERR, ERRSTR)
C
      INCLUDE 'implicit_none.finc'
C
C Purpose: Set value of integer parameter NYRAST
C
C Author:  John W. Campbell, June 1993
C
C Arguments:
C
      INTEGER IVAL
      INTEGER IERR
      CHARACTER*(*) ERRSTR

C  IVAL      (R)   Number of y rasters in image (> 0)
C  IERR      (W)   Error flag =0 OK
C                             =3 Value must be >0
C  ERRSTR    (W)   Error description string if error found
C
C====== GLOBALS:
C
      INCLUDE 'ldm_data.finc'
      EXTERNAL LDM_BDAT
C
C====== LOCALS:
C

C
C-------------------------------------------------------------------------------
C
      CALL LDM_ERR_I (IVAL, 0, 0, IERR, ERRSTR)
      IF (IERR.NE.0) RETURN
      NYRAS = IVAL
      IS_NYRAS = 1
      CH_NYRAS = CH_MASK
      RETURN
      END
