C LAST UPDATE: 
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C**************************
C**     LDM_SET_RAST     **
C**************************
C
C
CD-Doc:
C RASTer_size      SUBROUTINE LDM_SET_RAST (VALUE, IERR, ERRSTR)
CD-end
      SUBROUTINE LDM_SET_RAST (VALUE, IERR, ERRSTR)
C
      INCLUDE 'implicit_none.finc'
C
C Purpose: Set value of real parameter RASTER_SIZE
C
C Author:  John W. Campbell, June 1993
C
C Arguments:
C
      REAL VALUE
      INTEGER IERR
      CHARACTER*(*) ERRSTR

C  VALUE     (R)   Raster size in microns >0.0
C  IERR      (W)   Error flag =0 OK
C                             =3 Value must be >0.0
C  ERRSTR    (W)   Error description string if error found
C
C====== GLOBALS:
C
      INCLUDE 'ldm_data.finc'
      INCLUDE 'ldm_lrl.finc'
      EXTERNAL LDM_BDAT
C
C====== LOCALS:
C
C
C-------------------------------------------------------------------------------
C
      CALL LDM_ERR_R (VALUE, 2, 0.0, 0.0, 1, IERR, ERRSTR)
      IF (IERR.NE.0) RETURN
      RAST = VALUE
      IS_RAST = 1
      CH_RAST = CH_MASK
      ND_RAST = -1000
      CALL LDM_CLR_GEN (-1, -1, 2)
      RETURN
      END
