C LAST UPDATE: 
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C**************************
C**     LDM_SET_RMIN     **
C**************************
C
C
CD-Doc:
C RMIN             SUBROUTINE LDM_SET_RMIN (VALUE, IERR, ERRSTR)
CD-end
      SUBROUTINE LDM_SET_RMIN (VALUE, IERR, ERRSTR)
C
      INCLUDE 'implicit_none.finc'
C
C Purpose: Set value of real parameter RMIN
C
C Author:  John W. Campbell, June 1993
C
C Arguments:
C
      REAL VALUE
      INTEGER IERR
      CHARACTER*(*) ERRSTR

C  VALUE     (R)   'rmin' value in mm. (>= 0.0)
C  IERR      (W)   Error flag =0 OK
C                             =2 Value must be >=0.0
C  ERRSTR    (W)   Error description string if error found
C
C====== GLOBALS:
C
      INCLUDE 'ldm_data.finc'
      INCLUDE 'ldm_lrl.finc'
      EXTERNAL LDM_BDAT
C
C====== LOCALS:
C

C
C-------------------------------------------------------------------------------
C
      CALL LDM_ERR_R (VALUE, 1, 0.0, 0.0, 1, IERR, ERRSTR)
      IF (IERR.NE.0) RETURN
      RMIN = VALUE
      IS_RMIN = 1
      CH_RMIN = CH_MASK
      ND_RMIN = -1000
      CALL LDM_CLR_GEN (-1, -1, 2)
      RETURN
      END
