C LAST UPDATE: 
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C**************************
C**     LDM_SET_XHIGH    **
C**************************
C
C
CD-Doc:
C XHIGh            SUBROUTINE LDM_SET_XHIGH (VALUE, IERR, ERRSTR)
CD-end
      SUBROUTINE LDM_SET_XHIGH (VALUE, IERR, ERRSTR)
C
      INCLUDE 'implicit_none.finc'
C
C Purpose: Set value of real parameter XHIGH
C
C Author:  John W. Campbell, June 1993
C
C Arguments:
C
      REAL VALUE
      INTEGER IERR
      CHARACTER*(*) ERRSTR

C  VALUE     (R)   'xhigh' in rasters (0.0=max limit) (>= 0.0)
C  IERR      (W)   Error flag =0 OK
C                             =2 Value must be >=0.0
C  ERRSTR    (W)   Error description string if error found
C
C====== GLOBALS:
C
      INCLUDE 'ldm_data.finc'
      INCLUDE 'ldm_lrl.finc'
      EXTERNAL LDM_BDAT
C
C====== LOCALS:
C

C
C-------------------------------------------------------------------------------
C
      CALL LDM_ERR_R (VALUE, 1, 0.0, 0.0, 1, IERR, ERRSTR)
      IF (IERR.NE.0) RETURN
      XHIGH = VALUE
      IS_XHIGH = 1
      CH_XHIGH = CH_MASK
      ND_XHIGH = -1000
      CALL LDM_CLR_GEN (-1, -1, 2)
      RETURN
      END
