C
C LAST UPDATE:
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C******************************
C**     LFN_GET_PROFMAX      **
C******************************
C
CD-Routine: Get Profile Maximum - LFN_GET_PROFMAX
C This routine is used to return the maximum value for a requested
C profile calculated by a profile determining pass of the routine LFN_SAINT.
CD-end
CD-Fortran:
      SUBROUTINE LFN_GET_PROFMAX (IPROF, PROFMAX, IERR)
CD-end
      INCLUDE 'implicit_none.finc'
C
C PURPOSE: Get profile details for sprofile calculated by LFN_SAINT
C 
C AUTHOR: J.W. Campbell 
C
C ARGUMENTS:
C
      INTEGER IPROF
      REAL PROFMAX
      INTEGER IERR
CD-Parameters:
C   IPROF               i  (R) Profile no. (must be in range of those 
C   PROFMAX             r  (W) Maximum value in profile
C   IERR                i  (W) Error flag =0 OK, =1 profile no. out of range
CD-end
C
C====== Parameter statements
C 
      INCLUDE 'saint_limits.finc'
C
C====== GLOBALS:
C
      INCLUDE 'lfn_saint.finc'
C
C====== LOCALS:
C
      INTEGER I

C     INTEGER I       !Temp/loop variable
C
C------------------------------------------------------------------------------- 
C
      IERR = 0
      PROFMAX = 0.0
C
C====== Error checks
C
      IF (IPROF.LT.1.OR.IPROF.GT.NPROF_BIN) THEN
         IERR = 1
         RETURN
      END IF
      DO 10 I = 1, NUM_IN_PROF
         IF (PROF(I,IPROF).GT.PROFMAX) PROFMAX = PROF(I,IPROF)
 10   CONTINUE
      RETURN
      END
