C
C**************************
C**     LFN_SAINT_DF     **
C**************************

C
CD-Routine: Integration Parameter Defaults - LFN_SAINT_DF
C This routine returns some default values for use with the LFN_SAINT
C integration routine. Note that The profile intensity cutoff returned
C depends on the current image type.
CD-end
CD-Fortran:
      SUBROUTINE LFN_SAINT_DF (NPROF, PROMIN, PROF_ROT)
CD-end
      INCLUDE 'implicit_none.finc'
C
C Purpose: Return default parameters for automatic soft limit determination
C
C Author:  John W. Campbell, January 1996
C
C Arguments:
C
      INTEGER NPROF
      REAL PROMIN
      LOGICAL PROF_ROT
C
CD-Parameters:
C NPROF       i  (W)  No. of bins for determining intensity profiles (8)
C PROMIN      r  (W)  Minimum intensity of spot for inclusion in profiles
C                     100.0 for film, otherwise 600.0
C PROF_ROT    l  (W)  Rotate elliptical profiles flag (.TRUE.)
CD-end
C
C====== Parameter statements
C 

C
C====== GLOBALS:
C

C
C====== FUNCTION TYPES:
C

C
C====== LOCALS:
C
      INTEGER IMTYP
      INTEGER IFLAG
      CHARACTER*2 VALSTR

C     INTEGER IMTYP          !Image type flag
C     INTEGER IFLAG          !Parameter status flag
C     CHARACTER*2 VALSTR     !Value string (dummy)
C
C-------------------------------------------------------------------------------
C
      CALL LDM_GET_IMTYP (VALSTR, IMTYP, IFLAG)
      NPROF = 8
      IF (IMTYP.EQ.1) THEN
         PROMIN = 100.0
      ELSE
         PROMIN = 600.0
      END IF
      PROF_ROT = .TRUE.
      RETURN
      END
