C LAST UPDATE: 
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C**************************
C**     LRL_COUNTS       **
C**************************
C
CD-Routine: Get Spot Counts - LRL_COUNTS
C This routine returns counts of the number of spots/reflections in the
C Laue Reflection List in a number of different categories.
CD-end
CD-Fortran:
      SUBROUTINE LRL_COUNTS (NUMSPOTS, NUMREFL, NUMSING, NUMMULT,
     +                       NUMSPAT, NUMCLOS)
CD-end
      INCLUDE 'implicit_none.finc'
C
C Purpose: Return counts from the Laue Reflection List (LRL)
C
C Author:  John W. Campbell, July 1993
C
C Arguments:
C
      INTEGER NUMSPOTS
      INTEGER NUMREFL
      INTEGER NUMSING
      INTEGER NUMMULT
      INTEGER NUMSPAT
      INTEGER NUMCLOS
CD-Parameters:
C NUMSPOTS  i (W)  The number of spots in the Laue Reflection List
C NUMREFL   i (W)  The number of reflections in the Laue Reflection List
C NUMSING   i (W)  The number of single spots in the Laue Reflection List
C NUMMULT   i (W)  The number of multiple spots in the Laue Reflection List    
C NUMSPAT   i (W)  The number of spots marked as spatially overlapped in
C                  in the Laue Reflection List
C NUMCLOS   i  (W) The number of spots marked as too close to spatially 
C                  deconvolute at integration time in the Laue Reflection 
C                  List
CD-end
C====== GLOBALS:
C
      INCLUDE 'lrl_data.finc'
C
C====== FUNCTION TYPES:
C
      EXTERNAL LRL_BDAT
C
C-------------------------------------------------------------------------------
C
      NUMSPOTS = NUM_SPOTS
      NUMREFL = NUM_REFLEX
      NUMSING = NSING
      NUMMULT = NMULT
      NUMSPAT = NUM_SPAT
      NUMCLOS = NUM_CLOS
      RETURN
      END
