
C LAST UPDATE:
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C******************************
C**   LSC_DECONV_LOGOUTPUT   **
C******************************
C
CD- Routine: Writes deconvolution results into log-file - LSC_DECONV_LOGOUTPUT 
C This routine writes a summary of the deconvolution collected in 
C LSM_MULTIPLES_DECONV
CD-end
CD-Fortran:
C
      SUBROUTINE LSC_DECONV_LOGOUTPUT(IUN, NUMOUT)

CD-end
C
      INCLUDE 'implicit_none.finc'
C
C Purpose : Outputs deconvolution details to log-file
C
C Author:  Steffi Arzt, John Campbell, July 1997
C
C Arguments:
C
      INTEGER IUN
      INTEGER NUMOUT(12)
C
CD-Parameters:
C  IUN      i  (R)   Output unit number of log-file
C  NUMOUT() i  (R)   Array containing various details of the deconvolution
CD-end
C 
C====== PARAMETERS:
C
      INCLUDE 'limits.finc'   
C
C====== GLOBALS:
C
      INCLUDE 'use_reflns.finc'
C
C====== FUNCTION TYPES:
C
C
C====== LOCALS:
C
         WRITE(IUN,6180)
         WRITE(IUN,6190) NUMOUT(1)
         WRITE(IUN,6200)
         WRITE(IUN,6210) NUMOUT(2)
         WRITE(IUN,6220) NUMOUT(3)
         WRITE(IUN,6380) NUMOUT(4)
         WRITE(IUN,6230) NUMOUT(5)
         WRITE(IUN,6350) NUMOUT(6)
         WRITE(IUN,6360) NUMOUT(7)
         WRITE(IUN,6370) NUMOUT(8)
         WRITE(IUN,6300) 
         WRITE(IUN,6310) NUMOUT(9)
         WRITE(IUN,6330) NUMOUT(10)

         WRITE(IUN,6340) NUMOUT(11)
         WRITE(IUN,6390) SIGCUT_USE, NUMOUT(12)

         RETURN

 6180 FORMAT(///,' M U L T I P L E S    D E C O N V O L U T I O N',//)
 6190 FORMAT(' NUMBER OF EQUATIONS ELIMINATED BECAUSE LAMBDA',
     + ' NORMALISATION FACTOR OUT OF LAMBDA RANGE =',I5)
 6200 FORMAT(//,' SETS OF MULTIPLES FOR ATTEMPTED DECONVOLUTION',/)
 6210 FORMAT(' NUMBER OF UNIQUE SETS  OF  MULTIPLES  FOUND:',I5)
 6220 FORMAT(' NUMBER OF UNIQUES WITH SUFFICIENT EQUATIONS:',I5)
 6230 FORMAT(' NUMBER OF UNIQUES WITH  TOO  FEW  EQUATIONS   :',I5)
 6300 FORMAT(//,' SOLUTION OF THE HARMONIC DECONVOLUTION EQUATIONS',/)
 6310 FORMAT(' NUMBER OF SETS SOLVED WITH  POSITIVE  TERMS  ONLY:',I5)
 6350 FORMAT(' NUMBER OF SETS WITH 1 EQUATIONS AND 2 UNKNOWNS:',I5)
 6360 FORMAT(' NUMBER OF SETS WITH 2 EQUATIONS AND 3 UNKNOWNS:',I5)
 6370 FORMAT(' NUMBER OF SETS WITH 3 EQUATIONS AND 4 UNKNOWNS:',I5)
 6380 FORMAT(' NO. OF SETS WITH ALL REFL. SC= 0.0 AND/OR ',
     +       'LAMBDA<LAMBDAMIN:',I5)
 6330 FORMAT(' NUMBER OF UNSOLVED SETS  WITH  SINGULAR  MATRICES:',I5)
 6340 FORMAT(' NUMBER OF DECONV. REFL. ADDED AS  SINGLES TO LIST:',
     +     I5)
 6390 FORMAT(' NUMBER OF ADDED  REFLECTIONS  WITH  I >',F4.1,'*SIGMA:'
     +       ,I5,//)

      END
