
C LAST UPDATE:
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C***************************
C**      LSC_RFOUT        **
C***************************
C
C **** LSC SERVICE ROUTINE ONLY ****
C
      SUBROUTINE LSC_RFOUT (IUN, PLMERGE)
C
      INCLUDE 'implicit_none.finc'
C
C Purpose : Output R-factors
C
C Author:  Steffi Arzt, John Campbell, July 1997
C
C Arguments:
C
      INTEGER IUN
      LOGICAL PLMERGE
C
C Parameters:
C
C   IUN    i  (R)    Unit no. for the output
C PLMERGE  l  (R)    .true. = merged plate data
C                    .false. = plate data seperate
C
C====== PARAMETERS:
C
      INCLUDE 'limits.finc'
C
C====== GLOBALS:
C
      INCLUDE 'rout_arrays.finc'
C
C====== LOCALS:
C

C
C-------------------------------------------------------------------------------

      WRITE (IUN,6050) 
      IF (PLMERGE) WRITE (IUN,6055)
      WRITE (IUN,6060) RRN(1)
      WRITE (IUN,6090) NRR(1)
      WRITE (IUN,6070) RRN(2)
      WRITE (IUN,6090) NRR(2)
      WRITE (IUN,6080) RRN(3)
      WRITE (IUN,6090) NRR(3)
      WRITE (IUN,6100) RN
      WRITE (IUN,6200) GOFR
      RETURN
C
C====== Format Statement
C

 6050 FORMAT (//,' LAUE MERGING R-FACTORS = SUM(ABS(I-IMEAN)/SUM(I)',//,
     +        '                          (SUM OVER ALL MEASUREMENTS)')
 6055 FORMAT (/,' (Plate data merged)')
 6060 FORMAT (//,' RFACT1 =',F6.3,
     +        '     IMEAN FROM ALL MEASUREMENTS FOR',
     +        ' THE REFLECTION (I+ AND I-)')
 6070 FORMAT (//,' RFACT2 =',F6.3,'     IMEAN FROM ALL MEASUREMENTS OF',
     +        ' THE SAME SIGN (I+ OR I-)')
 6080 FORMAT (//,' RFACT3 =',F6.3,'     IMEAN FROM ALL MEASUREMENTS OF',
     +        ' THE SAME SIGN (I+ OR I-) AND WITH LAMBDA WITHIN 0.1A')
 6090 FORMAT (/,' N =',I6)
 6100 FORMAT (//,' (WITH WEIGHTED IMEAN RFACT1 =',F6.3,'   RFACT2 =',
     +        F6.3,'   RFACT3 =',F6.3,')')
 6200 FORMAT (//,' GOODNESS OF FIT GOF1 = ',F10.2,'   GOF2 = ',
     +        F10.2,'   GOF3 = ',F10.2)

      END
