
C LAST UPDATE:
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C******************************
C**     LSM_ABSOPT           **
C******************************
C
CD-Routine: Select absorption option - LSM_ABSOPT
C This routine is used to select the absorption correction option.
C The options are to model eitherthe gerneral path length, pg, or a
C normalised absorption scaling factor. It must be called prior to
C carrying out any LSM scaling or refinement.
CD-end
CD-Fortran:
      SUBROUTINE LSM_ABSOPT (IOPT)
CD-end
C
      INCLUDE 'implicit_none.finc'
C
C
C Purpose: Select absorption option
C
C Author:  Steffi Arzt, John Campbell, July 1997
C
C Arguments:
C
      INTEGER IOPT
C
CD-Parameters:
C  IOPT      i (R)   Flag =1 model absorption general path length (pg)
C                         =2 model normalised absorption scaling factor
CD-end
C
C Implementation note: Sets 'markup required' flag
C
C====== PARAMETERS:
C
      INCLUDE 'limits.finc'
C
C====== GLOBALS:
C
      INCLUDE 'other_scale.finc'
      INCLUDE 'lsm_flags.finc'
C
C------------------------------------------------------------------------------
C
      MARKUP_REQUIRED = .TRUE.
      IABSOPT = IOPT
      END
