
C LAST UPDATE:
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C******************************
C**     LSM_ABSOPT_LSP       **
C******************************
C
CD-Routine: Select absorption option - LSM_ABSOPT_LSP
C This routine calls LSM_ABSOPT with its parameter derived from the LSP
C parameter set.
CD-end
CD-Fortran:
      SUBROUTINE LSM_ABSOPT_LSP 
CD-end
C
      INCLUDE 'implicit_none.finc'
CD-Parameters:
C  none
CD-end
C
C====== PARAMETERS:
C
      INCLUDE 'limits.finc'
C
C====== GLOBALS:
C
      INCLUDE 'lsm_flags.finc'

C
C====== FUNCTION TYPES:
C

      INTEGER KDMSTR
      INTEGER LENSTR

C
C====== LOCALS:
C
C     
      INTEGER  IERR              
      INTEGER MAXE
      INTEGER IVAL(10)
      INTEGER NUM_INP
      INTEGER ISTAT 
      INTEGER ND(MAXCOEFFS)
      INTEGER ITYP                
      REAL FVAL(MAXVARR)
      CHARACTER*80 STR   
      CHARACTER*20 VALSTR
      CHARACTER*80 ERRSTR  

C     INTEGER  IERR                ! Error return flag
C     INTEGER MAXE                 ! Max length for error string
C     INTEGER IVAL(10)             ! Integer values array
C     INTEGER NUM_INP              ! No. of input values for a variable 
C                                  ! array param.
C     INTEGER ISTAT                ! Parameter status flag
C     INTEGER ND(MAXCOEFFS)        ! No. of decimal places flags array
C     INTEGER ITYP                 ! Parameter type
C     REAL FVAL(MAXVARR)           ! Real values array
C     CHARACTER*80 STR             ! Temporary string
C     CHARACTER*20 VALSTR          ! Dummy value string
C     CHARACTER*80 ERRSTR          ! Error string

C
C====== Set 'markup-required' flag
C

      MAXE = 80

      STR = 'ABSOPT'
      CALL KDMF_GETVALUE (KINDX, KDMSTR(STR),LENSTR(STR), 
     +                 1, 1, 2, KDMSTR(VALSTR), FVAL, ND, IVAL, 
     +                 NUM_INP, ISTAT, ITYP, KDMSTR(ERRSTR), 
     +                 MAXE, IERR)  
      IF (IERR.NE.0) RETURN  

      CALL LSM_ABSOPT(IVAL(1))
      RETURN
      END
